<?php

namespace RxConnexionBundle\Form;

use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\ORM\EntityRepository;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\OptionsResolver\OptionsResolver;
use RxConnexionBundle\Form\DataTransformer\DataTransformer;

class PatientChartProcedureForm extends AbstractType
{
    private $manager;

    public function __construct(ObjectManager $manager) {
        $this->manager = $manager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('action', HiddenType::class, array(
                'mapped' => false,
                'attr' => array(
                    'class' => 'form-action'
                )
            ))
            ->add('patient_chart', HiddenType::class, array(
                'attr' => array(
                    'value' => $options['patientChart_id']
                )
            ))
            ->add('id', HiddenType::class)
            ->add('note', TextareaType::class, array(
                'label' => 'Notes',
                'label_attr' => array(
                    'class' => 'middle'
                ),
                'required' => false,
                'attr' => array(
                    'rows' => 5
                )
            ))
            ->add('amount', TextType::class, array(
                'label' => 'Amount',
                'label_attr' => array(
                    'class' => 'required middle'
                ),
                'required' => true,
                'attr' => array(
                    'class' => 'amount'
                ),

            ))
            ->add('chart_procedure', HiddenType::class)
            ->addEventListener(FormEvents::PRE_SET_DATA, function(FormEvent $event) {

                $form = $event->getForm();
                $data = $event->getData();
                $chartProcedure = $data->getChartProcedure();

                $form
                    ->add('chart_procedure_desc', TextType::class, array(
                        'label' => 'Billing',
                        'label_attr' => array(
                            'class' => 'required middle'
                        ),
                        'required' => true,
                        'mapped' => false,
                        'data' => $chartProcedure ? $chartProcedure->getDescription() : ''
                    ));
            });

            $builder->get('chart_procedure')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:ChartProcedureEntity', false));
        $builder->get('patient_chart')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:PatientChartEntity', true));
    }

    public function getBlockPrefix()
    {
        return 'patient_chart_procedure';
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' 	  => 'RxConnexionBundle\Entity\PatientChartProcedureEntity',
            'csrf_protection' => true,
            'csrf_field_name' => '_token',
            // a unique key to help generate the secret token
            'intention'       => 'patient_chart_procedureEntity_intention',
            'action'          => 'n',
            'patientChart_id'      => null
        ));
    }
}